package cn.com.qmth.dp.examcloud.oe.entity.marking;

import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.Index;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;

/**
 * update by nikang on 2018/09/23.
 */
@Entity
@Table(name = "ec_m_mark_work", indexes = {
        @Index(name = "IDX_M_MARK_WORK_001", columnList = "rootOrgId,examId", unique = false) })
public class MarkWorkEntity extends IdEntity {

    private static final long serialVersionUID = 806290348733550628L;

    private String name;

    @Temporal(value = TemporalType.TIMESTAMP)
    private Date createdOn;

    /* 废弃字段 */
    private String examId;

    /* 评卷是否结束 */
    @NotNull
    private Boolean isEnd;

    /* 追加操作时间戳,用于创建完成是比对该值，看期间是否有新的追加 */
    private Long appendTime;

    private String remark;

    /**
     * 状态 0:创建中 1:创建成功 2:创建失败 3:追加中
     */
    private int status;

    @NotNull
    private Long rootOrgId;

    public MarkWorkEntity() {
    }

    public MarkWorkEntity(String name, String examId, Long rootOrgId) {
        this.name = name;
        this.examId = examId;
        this.rootOrgId = rootOrgId;
        this.createdOn = new Date();
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Date getCreatedOn() {
        return createdOn;
    }

    public void setCreatedOn(Date createdOn) {
        this.createdOn = createdOn;
    }

    public String getExamId() {
        return examId;
    }

    public void setExamId(String examId) {
        this.examId = examId;
    }


    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public Long getRootOrgId() {
        return rootOrgId;
    }

    public void setRootOrgId(Long rootOrgId) {
        this.rootOrgId = rootOrgId;
    }

    public Boolean getIsEnd() {
        return isEnd;
    }

    public void setIsEnd(Boolean isEnd) {
        this.isEnd = isEnd;
    }

    public Long getAppendTime() {
        return appendTime;
    }

    public void setAppendTime(Long appendTime) {
        this.appendTime = appendTime;
    }

}
